import { createAggregatedClient } from "@smithy/smithy-client";
import { CloudWatchClient } from "./CloudWatchClient";
import { DeleteAlarmsCommand, } from "./commands/DeleteAlarmsCommand";
import { DeleteAnomalyDetectorCommand, } from "./commands/DeleteAnomalyDetectorCommand";
import { DeleteDashboardsCommand, } from "./commands/DeleteDashboardsCommand";
import { DeleteInsightRulesCommand, } from "./commands/DeleteInsightRulesCommand";
import { DeleteMetricStreamCommand, } from "./commands/DeleteMetricStreamCommand";
import { DescribeAlarmHistoryCommand, } from "./commands/DescribeAlarmHistoryCommand";
import { DescribeAlarmsCommand, } from "./commands/DescribeAlarmsCommand";
import { DescribeAlarmsForMetricCommand, } from "./commands/DescribeAlarmsForMetricCommand";
import { DescribeAnomalyDetectorsCommand, } from "./commands/DescribeAnomalyDetectorsCommand";
import { DescribeInsightRulesCommand, } from "./commands/DescribeInsightRulesCommand";
import { DisableAlarmActionsCommand, } from "./commands/DisableAlarmActionsCommand";
import { DisableInsightRulesCommand, } from "./commands/DisableInsightRulesCommand";
import { EnableAlarmActionsCommand, } from "./commands/EnableAlarmActionsCommand";
import { EnableInsightRulesCommand, } from "./commands/EnableInsightRulesCommand";
import { GetDashboardCommand, } from "./commands/GetDashboardCommand";
import { GetInsightRuleReportCommand, } from "./commands/GetInsightRuleReportCommand";
import { GetMetricDataCommand, } from "./commands/GetMetricDataCommand";
import { GetMetricStatisticsCommand, } from "./commands/GetMetricStatisticsCommand";
import { GetMetricStreamCommand, } from "./commands/GetMetricStreamCommand";
import { GetMetricWidgetImageCommand, } from "./commands/GetMetricWidgetImageCommand";
import { ListDashboardsCommand, } from "./commands/ListDashboardsCommand";
import { ListManagedInsightRulesCommand, } from "./commands/ListManagedInsightRulesCommand";
import { ListMetricsCommand } from "./commands/ListMetricsCommand";
import { ListMetricStreamsCommand, } from "./commands/ListMetricStreamsCommand";
import { ListTagsForResourceCommand, } from "./commands/ListTagsForResourceCommand";
import { PutAnomalyDetectorCommand, } from "./commands/PutAnomalyDetectorCommand";
import { PutCompositeAlarmCommand, } from "./commands/PutCompositeAlarmCommand";
import { PutDashboardCommand, } from "./commands/PutDashboardCommand";
import { PutInsightRuleCommand, } from "./commands/PutInsightRuleCommand";
import { PutManagedInsightRulesCommand, } from "./commands/PutManagedInsightRulesCommand";
import { PutMetricAlarmCommand, } from "./commands/PutMetricAlarmCommand";
import { PutMetricDataCommand, } from "./commands/PutMetricDataCommand";
import { PutMetricStreamCommand, } from "./commands/PutMetricStreamCommand";
import { SetAlarmStateCommand, } from "./commands/SetAlarmStateCommand";
import { StartMetricStreamsCommand, } from "./commands/StartMetricStreamsCommand";
import { StopMetricStreamsCommand, } from "./commands/StopMetricStreamsCommand";
import { TagResourceCommand } from "./commands/TagResourceCommand";
import { UntagResourceCommand, } from "./commands/UntagResourceCommand";
const commands = {
    DeleteAlarmsCommand,
    DeleteAnomalyDetectorCommand,
    DeleteDashboardsCommand,
    DeleteInsightRulesCommand,
    DeleteMetricStreamCommand,
    DescribeAlarmHistoryCommand,
    DescribeAlarmsCommand,
    DescribeAlarmsForMetricCommand,
    DescribeAnomalyDetectorsCommand,
    DescribeInsightRulesCommand,
    DisableAlarmActionsCommand,
    DisableInsightRulesCommand,
    EnableAlarmActionsCommand,
    EnableInsightRulesCommand,
    GetDashboardCommand,
    GetInsightRuleReportCommand,
    GetMetricDataCommand,
    GetMetricStatisticsCommand,
    GetMetricStreamCommand,
    GetMetricWidgetImageCommand,
    ListDashboardsCommand,
    ListManagedInsightRulesCommand,
    ListMetricsCommand,
    ListMetricStreamsCommand,
    ListTagsForResourceCommand,
    PutAnomalyDetectorCommand,
    PutCompositeAlarmCommand,
    PutDashboardCommand,
    PutInsightRuleCommand,
    PutManagedInsightRulesCommand,
    PutMetricAlarmCommand,
    PutMetricDataCommand,
    PutMetricStreamCommand,
    SetAlarmStateCommand,
    StartMetricStreamsCommand,
    StopMetricStreamsCommand,
    TagResourceCommand,
    UntagResourceCommand,
};
export class CloudWatch extends CloudWatchClient {
}
createAggregatedClient(commands, CloudWatch);
