import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DeleteAnomalyDetectorCommand, se_DeleteAnomalyDetectorCommand } from "../protocols/Aws_query";
export { $Command };
export class DeleteAnomalyDetectorCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("GraniteServiceVersion20100801", "DeleteAnomalyDetector", {})
    .n("CloudWatchClient", "DeleteAnomalyDetectorCommand")
    .f(void 0, void 0)
    .ser(se_DeleteAnomalyDetectorCommand)
    .de(de_DeleteAnomalyDetectorCommand)
    .build() {
}
