import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DeleteMetricStreamCommand, se_DeleteMetricStreamCommand } from "../protocols/Aws_query";
export { $Command };
export class DeleteMetricStreamCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("GraniteServiceVersion20100801", "DeleteMetricStream", {})
    .n("CloudWatchClient", "DeleteMetricStreamCommand")
    .f(void 0, void 0)
    .ser(se_DeleteMetricStreamCommand)
    .de(de_DeleteMetricStreamCommand)
    .build() {
}
