import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DescribeInsightRulesCommand, se_DescribeInsightRulesCommand } from "../protocols/Aws_query";
export { $Command };
export class DescribeInsightRulesCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("GraniteServiceVersion20100801", "DescribeInsightRules", {})
    .n("CloudWatchClient", "DescribeInsightRulesCommand")
    .f(void 0, void 0)
    .ser(se_DescribeInsightRulesCommand)
    .de(de_DescribeInsightRulesCommand)
    .build() {
}
