import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_GetInsightRuleReportCommand, se_GetInsightRuleReportCommand } from "../protocols/Aws_query";
export { $Command };
export class GetInsightRuleReportCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("GraniteServiceVersion20100801", "GetInsightRuleReport", {})
    .n("CloudWatchClient", "GetInsightRuleReportCommand")
    .f(void 0, void 0)
    .ser(se_GetInsightRuleReportCommand)
    .de(de_GetInsightRuleReportCommand)
    .build() {
}
