import { getCompressionPlugin } from "@smithy/middleware-compression";
import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_PutMetricDataCommand, se_PutMetricDataCommand } from "../protocols/Aws_query";
export { $Command };
export class PutMetricDataCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
        getCompressionPlugin(config, {
            encodings: ["gzip"],
        }),
    ];
})
    .s("GraniteServiceVersion20100801", "PutMetricData", {})
    .n("CloudWatchClient", "PutMetricDataCommand")
    .f(void 0, void 0)
    .ser(se_PutMetricDataCommand)
    .de(de_PutMetricDataCommand)
    .build() {
}
