import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_PutMetricStreamCommand, se_PutMetricStreamCommand } from "../protocols/Aws_query";
export { $Command };
export class PutMetricStreamCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("GraniteServiceVersion20100801", "PutMetricStream", {})
    .n("CloudWatchClient", "PutMetricStreamCommand")
    .f(void 0, void 0)
    .ser(se_PutMetricStreamCommand)
    .de(de_PutMetricStreamCommand)
    .build() {
}
