import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { DeleteAlarmsCommandInput, DeleteAlarmsCommandOutput } from "../commands/DeleteAlarmsCommand";
import { DeleteAnomalyDetectorCommandInput, DeleteAnomalyDetectorCommandOutput } from "../commands/DeleteAnomalyDetectorCommand";
import { DeleteDashboardsCommandInput, DeleteDashboardsCommandOutput } from "../commands/DeleteDashboardsCommand";
import { DeleteInsightRulesCommandInput, DeleteInsightRulesCommandOutput } from "../commands/DeleteInsightRulesCommand";
import { DeleteMetricStreamCommandInput, DeleteMetricStreamCommandOutput } from "../commands/DeleteMetricStreamCommand";
import { DescribeAlarmHistoryCommandInput, DescribeAlarmHistoryCommandOutput } from "../commands/DescribeAlarmHistoryCommand";
import { DescribeAlarmsCommandInput, DescribeAlarmsCommandOutput } from "../commands/DescribeAlarmsCommand";
import { DescribeAlarmsForMetricCommandInput, DescribeAlarmsForMetricCommandOutput } from "../commands/DescribeAlarmsForMetricCommand";
import { DescribeAnomalyDetectorsCommandInput, DescribeAnomalyDetectorsCommandOutput } from "../commands/DescribeAnomalyDetectorsCommand";
import { DescribeInsightRulesCommandInput, DescribeInsightRulesCommandOutput } from "../commands/DescribeInsightRulesCommand";
import { DisableAlarmActionsCommandInput, DisableAlarmActionsCommandOutput } from "../commands/DisableAlarmActionsCommand";
import { DisableInsightRulesCommandInput, DisableInsightRulesCommandOutput } from "../commands/DisableInsightRulesCommand";
import { EnableAlarmActionsCommandInput, EnableAlarmActionsCommandOutput } from "../commands/EnableAlarmActionsCommand";
import { EnableInsightRulesCommandInput, EnableInsightRulesCommandOutput } from "../commands/EnableInsightRulesCommand";
import { GetDashboardCommandInput, GetDashboardCommandOutput } from "../commands/GetDashboardCommand";
import { GetInsightRuleReportCommandInput, GetInsightRuleReportCommandOutput } from "../commands/GetInsightRuleReportCommand";
import { GetMetricDataCommandInput, GetMetricDataCommandOutput } from "../commands/GetMetricDataCommand";
import { GetMetricStatisticsCommandInput, GetMetricStatisticsCommandOutput } from "../commands/GetMetricStatisticsCommand";
import { GetMetricStreamCommandInput, GetMetricStreamCommandOutput } from "../commands/GetMetricStreamCommand";
import { GetMetricWidgetImageCommandInput, GetMetricWidgetImageCommandOutput } from "../commands/GetMetricWidgetImageCommand";
import { ListDashboardsCommandInput, ListDashboardsCommandOutput } from "../commands/ListDashboardsCommand";
import { ListManagedInsightRulesCommandInput, ListManagedInsightRulesCommandOutput } from "../commands/ListManagedInsightRulesCommand";
import { ListMetricsCommandInput, ListMetricsCommandOutput } from "../commands/ListMetricsCommand";
import { ListMetricStreamsCommandInput, ListMetricStreamsCommandOutput } from "../commands/ListMetricStreamsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { PutAnomalyDetectorCommandInput, PutAnomalyDetectorCommandOutput } from "../commands/PutAnomalyDetectorCommand";
import { PutCompositeAlarmCommandInput, PutCompositeAlarmCommandOutput } from "../commands/PutCompositeAlarmCommand";
import { PutDashboardCommandInput, PutDashboardCommandOutput } from "../commands/PutDashboardCommand";
import { PutInsightRuleCommandInput, PutInsightRuleCommandOutput } from "../commands/PutInsightRuleCommand";
import { PutManagedInsightRulesCommandInput, PutManagedInsightRulesCommandOutput } from "../commands/PutManagedInsightRulesCommand";
import { PutMetricAlarmCommandInput, PutMetricAlarmCommandOutput } from "../commands/PutMetricAlarmCommand";
import { PutMetricDataCommandInput, PutMetricDataCommandOutput } from "../commands/PutMetricDataCommand";
import { PutMetricStreamCommandInput, PutMetricStreamCommandOutput } from "../commands/PutMetricStreamCommand";
import { SetAlarmStateCommandInput, SetAlarmStateCommandOutput } from "../commands/SetAlarmStateCommand";
import { StartMetricStreamsCommandInput, StartMetricStreamsCommandOutput } from "../commands/StartMetricStreamsCommand";
import { StopMetricStreamsCommandInput, StopMetricStreamsCommandOutput } from "../commands/StopMetricStreamsCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
/**
 * serializeAws_queryDeleteAlarmsCommand
 */
export declare const se_DeleteAlarmsCommand: (input: DeleteAlarmsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteAnomalyDetectorCommand
 */
export declare const se_DeleteAnomalyDetectorCommand: (input: DeleteAnomalyDetectorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteDashboardsCommand
 */
export declare const se_DeleteDashboardsCommand: (input: DeleteDashboardsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteInsightRulesCommand
 */
export declare const se_DeleteInsightRulesCommand: (input: DeleteInsightRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteMetricStreamCommand
 */
export declare const se_DeleteMetricStreamCommand: (input: DeleteMetricStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeAlarmHistoryCommand
 */
export declare const se_DescribeAlarmHistoryCommand: (input: DescribeAlarmHistoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeAlarmsCommand
 */
export declare const se_DescribeAlarmsCommand: (input: DescribeAlarmsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeAlarmsForMetricCommand
 */
export declare const se_DescribeAlarmsForMetricCommand: (input: DescribeAlarmsForMetricCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeAnomalyDetectorsCommand
 */
export declare const se_DescribeAnomalyDetectorsCommand: (input: DescribeAnomalyDetectorsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeInsightRulesCommand
 */
export declare const se_DescribeInsightRulesCommand: (input: DescribeInsightRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDisableAlarmActionsCommand
 */
export declare const se_DisableAlarmActionsCommand: (input: DisableAlarmActionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDisableInsightRulesCommand
 */
export declare const se_DisableInsightRulesCommand: (input: DisableInsightRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryEnableAlarmActionsCommand
 */
export declare const se_EnableAlarmActionsCommand: (input: EnableAlarmActionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryEnableInsightRulesCommand
 */
export declare const se_EnableInsightRulesCommand: (input: EnableInsightRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryGetDashboardCommand
 */
export declare const se_GetDashboardCommand: (input: GetDashboardCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryGetInsightRuleReportCommand
 */
export declare const se_GetInsightRuleReportCommand: (input: GetInsightRuleReportCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryGetMetricDataCommand
 */
export declare const se_GetMetricDataCommand: (input: GetMetricDataCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryGetMetricStatisticsCommand
 */
export declare const se_GetMetricStatisticsCommand: (input: GetMetricStatisticsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryGetMetricStreamCommand
 */
export declare const se_GetMetricStreamCommand: (input: GetMetricStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryGetMetricWidgetImageCommand
 */
export declare const se_GetMetricWidgetImageCommand: (input: GetMetricWidgetImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryListDashboardsCommand
 */
export declare const se_ListDashboardsCommand: (input: ListDashboardsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryListManagedInsightRulesCommand
 */
export declare const se_ListManagedInsightRulesCommand: (input: ListManagedInsightRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryListMetricsCommand
 */
export declare const se_ListMetricsCommand: (input: ListMetricsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryListMetricStreamsCommand
 */
export declare const se_ListMetricStreamsCommand: (input: ListMetricStreamsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutAnomalyDetectorCommand
 */
export declare const se_PutAnomalyDetectorCommand: (input: PutAnomalyDetectorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutCompositeAlarmCommand
 */
export declare const se_PutCompositeAlarmCommand: (input: PutCompositeAlarmCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutDashboardCommand
 */
export declare const se_PutDashboardCommand: (input: PutDashboardCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutInsightRuleCommand
 */
export declare const se_PutInsightRuleCommand: (input: PutInsightRuleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutManagedInsightRulesCommand
 */
export declare const se_PutManagedInsightRulesCommand: (input: PutManagedInsightRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutMetricAlarmCommand
 */
export declare const se_PutMetricAlarmCommand: (input: PutMetricAlarmCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutMetricDataCommand
 */
export declare const se_PutMetricDataCommand: (input: PutMetricDataCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutMetricStreamCommand
 */
export declare const se_PutMetricStreamCommand: (input: PutMetricStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_querySetAlarmStateCommand
 */
export declare const se_SetAlarmStateCommand: (input: SetAlarmStateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryStartMetricStreamsCommand
 */
export declare const se_StartMetricStreamsCommand: (input: StartMetricStreamsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryStopMetricStreamsCommand
 */
export declare const se_StopMetricStreamsCommand: (input: StopMetricStreamsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryTagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryUntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_queryDeleteAlarmsCommand
 */
export declare const de_DeleteAlarmsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteAlarmsCommandOutput>;
/**
 * deserializeAws_queryDeleteAnomalyDetectorCommand
 */
export declare const de_DeleteAnomalyDetectorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteAnomalyDetectorCommandOutput>;
/**
 * deserializeAws_queryDeleteDashboardsCommand
 */
export declare const de_DeleteDashboardsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDashboardsCommandOutput>;
/**
 * deserializeAws_queryDeleteInsightRulesCommand
 */
export declare const de_DeleteInsightRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteInsightRulesCommandOutput>;
/**
 * deserializeAws_queryDeleteMetricStreamCommand
 */
export declare const de_DeleteMetricStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteMetricStreamCommandOutput>;
/**
 * deserializeAws_queryDescribeAlarmHistoryCommand
 */
export declare const de_DescribeAlarmHistoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAlarmHistoryCommandOutput>;
/**
 * deserializeAws_queryDescribeAlarmsCommand
 */
export declare const de_DescribeAlarmsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAlarmsCommandOutput>;
/**
 * deserializeAws_queryDescribeAlarmsForMetricCommand
 */
export declare const de_DescribeAlarmsForMetricCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAlarmsForMetricCommandOutput>;
/**
 * deserializeAws_queryDescribeAnomalyDetectorsCommand
 */
export declare const de_DescribeAnomalyDetectorsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAnomalyDetectorsCommandOutput>;
/**
 * deserializeAws_queryDescribeInsightRulesCommand
 */
export declare const de_DescribeInsightRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInsightRulesCommandOutput>;
/**
 * deserializeAws_queryDisableAlarmActionsCommand
 */
export declare const de_DisableAlarmActionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableAlarmActionsCommandOutput>;
/**
 * deserializeAws_queryDisableInsightRulesCommand
 */
export declare const de_DisableInsightRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableInsightRulesCommandOutput>;
/**
 * deserializeAws_queryEnableAlarmActionsCommand
 */
export declare const de_EnableAlarmActionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableAlarmActionsCommandOutput>;
/**
 * deserializeAws_queryEnableInsightRulesCommand
 */
export declare const de_EnableInsightRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableInsightRulesCommandOutput>;
/**
 * deserializeAws_queryGetDashboardCommand
 */
export declare const de_GetDashboardCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDashboardCommandOutput>;
/**
 * deserializeAws_queryGetInsightRuleReportCommand
 */
export declare const de_GetInsightRuleReportCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetInsightRuleReportCommandOutput>;
/**
 * deserializeAws_queryGetMetricDataCommand
 */
export declare const de_GetMetricDataCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMetricDataCommandOutput>;
/**
 * deserializeAws_queryGetMetricStatisticsCommand
 */
export declare const de_GetMetricStatisticsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMetricStatisticsCommandOutput>;
/**
 * deserializeAws_queryGetMetricStreamCommand
 */
export declare const de_GetMetricStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMetricStreamCommandOutput>;
/**
 * deserializeAws_queryGetMetricWidgetImageCommand
 */
export declare const de_GetMetricWidgetImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMetricWidgetImageCommandOutput>;
/**
 * deserializeAws_queryListDashboardsCommand
 */
export declare const de_ListDashboardsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDashboardsCommandOutput>;
/**
 * deserializeAws_queryListManagedInsightRulesCommand
 */
export declare const de_ListManagedInsightRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListManagedInsightRulesCommandOutput>;
/**
 * deserializeAws_queryListMetricsCommand
 */
export declare const de_ListMetricsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListMetricsCommandOutput>;
/**
 * deserializeAws_queryListMetricStreamsCommand
 */
export declare const de_ListMetricStreamsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListMetricStreamsCommandOutput>;
/**
 * deserializeAws_queryListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_queryPutAnomalyDetectorCommand
 */
export declare const de_PutAnomalyDetectorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutAnomalyDetectorCommandOutput>;
/**
 * deserializeAws_queryPutCompositeAlarmCommand
 */
export declare const de_PutCompositeAlarmCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutCompositeAlarmCommandOutput>;
/**
 * deserializeAws_queryPutDashboardCommand
 */
export declare const de_PutDashboardCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutDashboardCommandOutput>;
/**
 * deserializeAws_queryPutInsightRuleCommand
 */
export declare const de_PutInsightRuleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutInsightRuleCommandOutput>;
/**
 * deserializeAws_queryPutManagedInsightRulesCommand
 */
export declare const de_PutManagedInsightRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutManagedInsightRulesCommandOutput>;
/**
 * deserializeAws_queryPutMetricAlarmCommand
 */
export declare const de_PutMetricAlarmCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutMetricAlarmCommandOutput>;
/**
 * deserializeAws_queryPutMetricDataCommand
 */
export declare const de_PutMetricDataCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutMetricDataCommandOutput>;
/**
 * deserializeAws_queryPutMetricStreamCommand
 */
export declare const de_PutMetricStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutMetricStreamCommandOutput>;
/**
 * deserializeAws_querySetAlarmStateCommand
 */
export declare const de_SetAlarmStateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SetAlarmStateCommandOutput>;
/**
 * deserializeAws_queryStartMetricStreamsCommand
 */
export declare const de_StartMetricStreamsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartMetricStreamsCommandOutput>;
/**
 * deserializeAws_queryStopMetricStreamsCommand
 */
export declare const de_StopMetricStreamsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopMetricStreamsCommandOutput>;
/**
 * deserializeAws_queryTagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_queryUntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
