import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
  Provider,
} from "@smithy/types";
import { CloudWatchClientResolvedConfig } from "../CloudWatchClient";
export interface CloudWatchHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface CloudWatchHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    CloudWatchClientResolvedConfig,
    HandlerExecutionContext,
    CloudWatchHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultCloudWatchHttpAuthSchemeParametersProvider: (
  config: CloudWatchClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<CloudWatchHttpAuthSchemeParameters>;
export interface CloudWatchHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<CloudWatchHttpAuthSchemeParameters> {}
export declare const defaultCloudWatchHttpAuthSchemeProvider: CloudWatchHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  authSchemePreference?: string[] | Provider<string[]>;
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: CloudWatchHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly authSchemePreference: Provider<string[]>;
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: CloudWatchHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
