/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __awaiter } from "tslib";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT License.
import { ContainerInstanceManagementClient } from "@azure/arm-containerinstance";
import { DefaultAzureCredential } from "@azure/identity";
import * as dotenv from "dotenv";
dotenv.config();
/**
 * This sample demonstrates how to Updates container group tags with specified values.
 *
 * @summary Updates container group tags with specified values.
 * x-ms-original-file: specification/containerinstance/resource-manager/Microsoft.ContainerInstance/stable/2023-05-01/examples/ContainerGroupsUpdate.json
 */
function containerGroupsUpdate() {
    return __awaiter(this, void 0, void 0, function* () {
        const subscriptionId = process.env["CONTAINERINSTANCE_SUBSCRIPTION_ID"] || "subid";
        const resourceGroupName = process.env["CONTAINERINSTANCE_RESOURCE_GROUP"] || "demoResource";
        const containerGroupName = "demo1";
        const resource = {
            tags: { tag1key: "tag1Value", tag2key: "tag2Value" }
        };
        const credential = new DefaultAzureCredential();
        const client = new ContainerInstanceManagementClient(credential, subscriptionId);
        const result = yield client.containerGroups.update(resourceGroupName, containerGroupName, resource);
        console.log(result);
    });
}
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        containerGroupsUpdate();
    });
}
main().catch(console.error);
//# sourceMappingURL=containerGroupsUpdateSample.js.map