/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */

import {
  ContainersListLogsOptionalParams,
  ContainersListLogsResponse,
  ContainerExecRequest,
  ContainersExecuteCommandOptionalParams,
  ContainersExecuteCommandResponse,
  ContainersAttachOptionalParams,
  ContainersAttachResponse
} from "../models";

/** Interface representing a Containers. */
export interface Containers {
  /**
   * Get the logs for a specified container instance in a specified resource group and container group.
   * @param resourceGroupName The name of the resource group.
   * @param containerGroupName The name of the container group.
   * @param containerName The name of the container instance.
   * @param options The options parameters.
   */
  listLogs(
    resourceGroupName: string,
    containerGroupName: string,
    containerName: string,
    options?: ContainersListLogsOptionalParams
  ): Promise<ContainersListLogsResponse>;
  /**
   * Executes a command for a specific container instance in a specified resource group and container
   * group.
   * @param resourceGroupName The name of the resource group.
   * @param containerGroupName The name of the container group.
   * @param containerName The name of the container instance.
   * @param containerExecRequest The request for the exec command.
   * @param options The options parameters.
   */
  executeCommand(
    resourceGroupName: string,
    containerGroupName: string,
    containerName: string,
    containerExecRequest: ContainerExecRequest,
    options?: ContainersExecuteCommandOptionalParams
  ): Promise<ContainersExecuteCommandResponse>;
  /**
   * Attach to the output stream of a specific container instance in a specified resource group and
   * container group.
   * @param resourceGroupName The name of the resource group.
   * @param containerGroupName The name of the container group.
   * @param containerName The name of the container instance.
   * @param options The options parameters.
   */
  attach(
    resourceGroupName: string,
    containerGroupName: string,
    containerName: string,
    options?: ContainersAttachOptionalParams
  ): Promise<ContainersAttachResponse>;
}
