/**
 * Plugin class providing {@link @tapjs/before!Before#before} on the
 * {@link @tapjs/test!index.Test} class.
 *
 * @module
 */
import { TapPlugin, TestBase } from '@tapjs/core';
/**
 * Implementation class returned by plugin function
 */
export declare class Before {
    #private;
    constructor(t: TestBase);
    /**
     * Just run the supplied function right away, but do not run any
     * child tests until it has completed.
     *
     * This is handy when some setup may require asynchronous actions, and
     * tests should wait until after it completes.
     *
     * @group Test Lifecycle Management
     */
    before(fn: () => any): void;
}
/**
 * Plugin method that creates the {@link @tapjs/before!Before} instance
 */
export declare const plugin: TapPlugin<Before>;
//# sourceMappingURL=index.d.ts.map