import { resolveImport } from 'resolve-import';
export const resolveMockEntryPoint = async (url, module, serviceKey, key, caller) => {
    let mockedModuleURL;
    if (module.startsWith('./') || module.startsWith('../')) {
        mockedModuleURL = new URL(module, url);
    }
    else {
        const res = (await resolveImport(module, url));
        // caught at the exposed API, defense in depth only
        // but the experience if it throws here is unhelpful.
        /* c8 ignore start */
        if (typeof res === 'string') {
            const er = new TypeError('node builtins cannot be mock imported');
            Error.captureStackTrace(er, caller);
            throw er;
        }
        /* c8 ignore stop */
        mockedModuleURL = res;
    }
    mockedModuleURL.searchParams.set('tapmock', `${serviceKey}.${key}`);
    return String(mockedModuleURL);
};
//# sourceMappingURL=resolve-mock-entry-point.js.map