import { format } from 'util';
import { locFromAt } from './loc-from-at.js';
export const commentMethod = (stream, diagsMap) => {
    return function comment(...args) {
        const message = format(...args);
        const diags = diagsMap.get(this);
        const m = {
            ...locFromAt(comment),
            nesting: this.nestingLevel,
            message,
        };
        if (diags)
            diags.push(m);
        else
            stream.diagnostic(m);
    };
};
//# sourceMappingURL=comment.js.map