"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findSourceMapSafe = void 0;
const module_1 = require("module");
const path_to_url_js_1 = require("./path-to-url.js");
const sourceMaps = new Map();
const findSourceMapSafe = (s) => {
    // Have to look up by URL, because the ?tapmock param will be in
    // the internal key used by node, as those are "different" modules.
    const mod = (0, path_to_url_js_1.pathToURL)(s);
    const c = sourceMaps.get(mod);
    if (c)
        return c;
    // this can throw in some cases, eg if the sourcemap file is missing
    try {
        const sm = (0, module_1.findSourceMap)(mod);
        if (sm)
            sourceMaps.set(mod, sm);
        return sm;
        // only throws on node 20
        /* c8 ignore start */
    }
    catch {
        return false;
    }
    /* c8 ignore stop */
};
exports.findSourceMapSafe = findSourceMapSafe;
//# sourceMappingURL=find-source-map-safe.js.map