"use strict";
// read the file and json decode it, if anything fails, return {}
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeJSON = exports.safeJSONSync = void 0;
const fs_1 = require("fs");
const promises_1 = require("fs/promises");
const safeJSONSync = (f) => {
    try {
        return JSON.parse((0, fs_1.readFileSync)(f, 'utf8'));
    }
    catch (e) {
        return {};
    }
};
exports.safeJSONSync = safeJSONSync;
const safeJSON = (f) => (0, promises_1.readFile)(f, 'utf8')
    .then(d => JSON.parse(d))
    .catch(() => ({}));
exports.safeJSON = safeJSON;
//# sourceMappingURL=json-file.js.map