"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.importMatch = exports.legacyMatch = exports.importLoader = exports.legacyLoader = void 0;
const path_1 = require("path");
const get_import_meta_url_js_1 = require("./get-import-meta-url.js");
const url_1 = require("url");
exports.legacyLoader = (0, get_import_meta_url_js_1.getImportMetaURL)('../esm/loader-legacy.mjs');
exports.importLoader = (0, get_import_meta_url_js_1.getImportMetaURL)('../esm/import.mjs');
const legacyLoaderPath = (0, url_1.fileURLToPath)(exports.legacyLoader);
const importLoaderPath = (0, url_1.fileURLToPath)(exports.importLoader);
const legacyMatch = (p) => {
    const d = p.startsWith('file://')
        ? (0, url_1.fileURLToPath)(p)
        : decodeURIComponent(p);
    return (d === '@tapjs/processinfo/loader' ||
        p === exports.legacyLoader ||
        (0, path_1.resolve)(d) === legacyLoaderPath);
};
exports.legacyMatch = legacyMatch;
const importMatch = (p) => {
    const d = p.startsWith('file://')
        ? (0, url_1.fileURLToPath)(p)
        : decodeURIComponent(p);
    return (d === '@tapjs/processinfo/import' ||
        p === exports.importLoader ||
        (0, path_1.resolve)(d) === importLoaderPath);
};
exports.importMatch = importMatch;
//# sourceMappingURL=loader-paths.js.map