"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setSources = void 0;
const url_1 = require("url");
const lookup_sources_js_1 = require("./lookup-sources.js");
const url_to_path_js_1 = require("./url-to-path.js");
let sourcesCache;
// set the processInfo.sources for a given file, but don't clobber
// if called multiple times, or create duplicate entries.
// Should only be called *after* the file in question has been loaded.
const setSources = (pi) => {
    sourcesCache ??= (0, lookup_sources_js_1.getSources)();
    for (const [url, sources] of sourcesCache.entries()) {
        const file = (0, url_1.fileURLToPath)(url);
        const s = pi.sources[file] || [];
        s.push(...sources.map(s => (0, url_to_path_js_1.urlToPath)(s)));
        pi.sources[file] = [...new Set(s)];
    }
};
exports.setSources = setSources;
//# sourceMappingURL=set-sources.js.map