"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.spawnOpts = void 0;
const node_options_env_js_1 = require("./node-options-env.js");
const p = process;
const spawnOpts = (options, exclude, args) => {
    const { externalID, ...rest } = options;
    const env = { ...(options.env || p.env) };
    // only add if lacking in args, but this can come in multiple ways
    const a = [
        ...(options.execArgv ?? []),
        ...(args ?? []),
        ...(options.args ?? []),
    ];
    env.NODE_OPTIONS = (0, node_options_env_js_1.nodeOptionsEnv)(env, a);
    if (externalID) {
        env._TAPJS_PROCESSINFO_EXTERNAL_ID_ = externalID;
    }
    if (exclude) {
        env._TAPJS_PROCESSINFO_EXCLUDE_ = String(exclude);
    }
    return { ...rest, env };
};
exports.spawnOpts = spawnOpts;
//# sourceMappingURL=spawn-opts.js.map