import { LoadedConfig } from '@tapjs/config';
import { Base, TestBase } from '@tapjs/core';
export type LogEntry = StdioLog | TestLog | ConsoleLog;
export interface TestLog {
    test: Base;
    previous?: LogEntry;
}
export declare const isTestLog: (p?: LogEntry) => p is TestLog;
export interface ConsoleLog {
    text: string;
    previous?: LogEntry;
}
export declare const isConsoleLog: (p?: LogEntry) => p is ConsoleLog;
export interface StdioLog extends ConsoleLog {
    name: string;
    fd: 0 | 1 | 2;
}
export declare const isStdioLog: (p?: LogEntry) => p is StdioLog;
export declare const useLog: (test: TestBase, config: LoadedConfig, includeTests?: boolean) => LogEntry[];
//# sourceMappingURL=use-log.d.ts.map