import { Box } from 'ink';
import React from 'react';
import { useIsDone } from './hooks/use-is-done.js';
import { useSubtests } from './hooks/use-subtests.js';
import { TestSummary } from './test-summary.js';
export const ResultDetailList = ({ test, Banner, filter = ({ counts, parser }) => !!counts.fail || !!counts.skip || !!counts.todo || !parser.ok, }) => {
    const tests = useSubtests(test, 'finished');
    const t = tests.filter(filter);
    const done = useIsDone(test);
    return !done ?
        React.createElement(React.Fragment, null)
        : React.createElement(Box, { flexDirection: "column" },
            Banner ?
                React.createElement(Banner, null)
                : React.createElement(React.Fragment, null),
            t.map((test, key) => (React.createElement(Box, { key: key, flexDirection: "column", marginTop: 1 },
                React.createElement(TestSummary, { test: test, details: true })))));
};
//# sourceMappingURL=result-detail-list.js.map