import type { LoadedConfig } from '@tapjs/config';
import type { TAP } from '@tapjs/core';
/**
 * Return type indicates whether or not stderr is also being handled.
 * If a stream or raw TAP is used, then `false` is returned, indicating
 * that child test process stderr is *not* handled, and stdio should be
 * inherited from main runner process.
 * If a React component is used, then it's responsible for handling the
 * stderr of any spawned child processes, and this function returns true
 * to indicate that stdio should be piped.
 */
export declare const handleReporter: (t: TAP, config: LoadedConfig) => Promise<boolean>;
//# sourceMappingURL=handle-reporter.d.ts.map