import { Minipass } from 'minipass';
import { mkdirpSync } from 'mkdirp';
import { createWriteStream } from 'node:fs';
import { dirname, resolve } from 'node:path';
export const outputFile = (t, config, hasReporter) => {
    const outputFile = config.get('output-file');
    if (outputFile) {
        mkdirpSync(dirname(resolve(outputFile)));
        const m = new Minipass({ encoding: 'utf8' });
        if (!hasReporter) {
            m.pipe(process.stdout);
            t.register();
        }
        m.pipe(createWriteStream(resolve(outputFile)));
        t.pipe(m);
    }
};
//# sourceMappingURL=output-file.js.map