"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cleanCWD = void 0;
const core_1 = require("@tapjs/core");
const node_url_1 = require("node:url");
// escape a string to json, then unwrap the "
// used for cwd detection
const esc = (s) => {
    const j = JSON.stringify(s);
    return j.substring(1, j.length - 1);
};
const cwdURL = String((0, node_url_1.pathToFileURL)(core_1.cwd)).substring('file://'.length);
const cwdPosix = core_1.cwd.replace(/\\/g, '/');
const cwdLcase = core_1.cwd.toLowerCase();
const cwdPosixLcase = cwdPosix.toLowerCase();
const cwds = new Set([cwdURL, core_1.cwd, cwdPosix, cwdLcase, cwdPosixLcase]);
for (const c of [...cwds]) {
    cwds.add(esc(c));
    cwds.add(esc(esc(c)));
    cwds.add(esc(esc(esc(c))));
    cwds.add(esc(esc(esc(esc(c)))));
}
const reSpecial = /[/\-\\^$*+?.()|[\]{}]/g;
const escapeRegex = (s) => s.replace(reSpecial, '\\$&');
const cleanCWD = (snap) => {
    const tag = '{CWD}';
    for (const c of cwds) {
        const r = new RegExp(escapeRegex(c), 'gi');
        snap = snap.replace(r, tag);
    }
    return snap;
};
exports.cleanCWD = cleanCWD;
//# sourceMappingURL=clean-cwd.js.map