"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = exports.SpawnPlugin = void 0;
const core_1 = require("@tapjs/core");
class SpawnPlugin {
    #t;
    constructor(t) {
        this.#t = t;
    }
    spawn(cmd, args, options, name) {
        if (typeof args === 'string') {
            args = [args];
        }
        if (typeof options === 'string') {
            name = options;
            options = {};
        }
        if (typeof args === 'object' && !Array.isArray(args)) {
            options = args;
            args = [];
        }
        options = options || {};
        if (options.name === undefined && name !== undefined) {
            options.name = name;
        }
        options.command = cmd;
        options.args = args !== undefined ? args : [];
        return this.#t.sub(core_1.Spawn, options, this.#t.t.spawn);
    }
}
exports.SpawnPlugin = SpawnPlugin;
const plugin = (t) => new SpawnPlugin(t);
exports.plugin = plugin;
//# sourceMappingURL=index.js.map