declare const isCompiled: unique symbol;
export interface LineRef {
    fileName: string;
    lineNumber: number;
    columnNumber: number;
    [isCompiled]: true;
}
export interface NativeLineRef {
    isNative: true;
    [isCompiled]: true;
}
export declare const isLineRef: (lr?: Compiled | undefined) => lr is LineRef;
export interface Compiled {
    fname?: string;
    fileName?: string;
    lineNumber?: number;
    columnNumber?: number;
    generated?: LineRef;
    evalOrigin?: Compiled;
    isEval?: boolean;
    isNative?: boolean;
    [isCompiled]: true;
}
export declare const isCompiledCallSiteLine: (c: any) => boolean;
export declare const parseCallSiteLine: (line: string) => Compiled;
export {};
//# sourceMappingURL=parse.d.ts.map